// Parse configuration lines
#include <string.h>
#include "parser.hpp"

int ParseString(char *string, char *param, char *result) {
    int i, j;

    i = strlen(param);
    if (strnicmp( string, param, i ) == 0) {
        if (string[i] == ' ') {
            while (string[i] == ' ')
                i++;
            for (j = strlen(string) - 1; (j >= i) && string[j] == ' '; j--)
                ;
            if (j >= i) {
              memcpy( result, &string[i], j-i+1 );
              result[j-i+1] = '\0';
              return 1;
            }
        }
    }
    return 0;
}

int ParseEmptyString(char *string, char *param, char *result) {
    int i, j;

    i = strlen(param);
    if (strnicmp( string, param, i ) == 0) {
        if (string[i] == '\0') {
            *result = '\0';
            return 1;
        }
        if (string[i] == ' ') {
            while (string[i] == ' ')
                i++;
            if (string[i] == '\0') {
                *result = '\0';
                return 1;
            }
            for (j = strlen(string) - 1; (j >= i) && string[j] == ' '; j--)
                ;
            if (j >= i) {
              memcpy( result, &string[i], j-i+1 );
              result[j-i+1] = '\0';
              return 1;
            }
        }
    }
    return 0;
}
    
int ParseQuotedString(char *string, char *param, char *result) {
    int i, j;

    i = strlen(param);
    if (strnicmp( string, param, i ) == 0) {
        if (string[i] == ' ') {
            while (string[i] == ' ')
                i++;
            if (string[i] != '"')
                return 0;
            i++;
            for (j = strlen(string) - 1; (j >= i) && string[j] == ' '; j--)
                ;
            if (string[j] != '"')
                return 0;
            // Empty string?
            if (j == i) {
                *result = '\0';
                return 1;
            }
            else {
                j--;
                if (j >= i) {
                    memcpy( result, &string[i], j-i+1 );
                    result[j-i+1] = '\0';
                    return 1;
                }
            }
        }
    }
    return 0;
}

int ParseYesNo(char *string, char *param, int &result) {
    int  i, j;
    char YesNo[4];

    i = strlen( param );
    if (strnicmp( string, param, i ) == 0) {
        if (string[i] == ' ') {
            while (string[i] == ' ')
                i++;
            for (j = strlen(string) - 1; (j >= i) && string[j] == ' '; j--)
              ;
            if ((j - i) >= 0 && ((j - i) <= 2)) {
              memcpy( YesNo, &string[i], j-i+1 );
              YesNo[j-i+1] = 0;
              if (stricmp( YesNo, "Yes" ) == 0) {
                  result = 1;
                  return 1;
              }
              if (stricmp( YesNo, "No" ) == 0) {
                  result = 0;
                  return 1;
              }
            }
        }
    }
    return 0;
}